﻿$(document).ready(doc_ready);

// ToDo: specify the correct controls prefixes (according to their type)
var btnNewPhoneNumber,
	txtNewPhoneNumberNumber,
	ddlNewPhoneNumberType,
	btnNewPhoneNumberCancel,
	lblNewPhoneNumberMessage,
	txtEditPhoneNumberNumber,
	ddlEditPhoneNumberType,
    btnEditPhoneNumberCancel,
	lblEditPhoneNumberMessage,
	lblPhoneNumbersMessage;

function doc_ready() {
	try	{
		initControls();

		fixColorbox();

		showNewPhoneNumberPopUpIfNecessary();
		showEditPhoneNumberPopUpIfNecessary();
	} catch(e) {
		showPhoneNumbersErrorMessage(e.message);
	}
}

function initControls() {
    // ToDo: specify the correct controls prefixes (according to their type)
	btnNewPhoneNumber = $("#btnNewPhoneNumber");
	txtNewPhoneNumberNumber = $("#txtNewPhoneNumberNumber");
	ddlNewPhoneNumberType = $("#ddlNewPhoneNumberType");
	btnNewPhoneNumberCancel = $("#btnNewPhoneNumberCancel");
	lblNewPhoneNumberMessage = $("#lblNewPhoneNumberMessage");
	txtEditPhoneNumberNumber = $("#txtEditPhoneNumberNumber");
	ddlEditPhoneNumberType = $("#ddlEditPhoneNumberType");
    btnEditPhoneNumberCancel = $("#btnEditPhoneNumberCancel");
	lblEditPhoneNumberMessage = $("#lblEditPhoneNumberMessage");
	lblPhoneNumbersMessage = $("#lblPhoneNumbersMessage");

	btnNewPhoneNumber.click(btnNewPhoneNumber_click);
    btnNewPhoneNumberCancel.click(btnCancel_click);
    btnEditPhoneNumberCancel.click(btnCancel_click);
}

function fixColorbox() {
    var pageForm = $( $("form")[0] );
    var cboxOverlay = $("#cboxOverlay");
    var colorbox = $("#colorbox");

    // move from "body" tag to "form" tag
    pageForm.prepend(colorbox);
    pageForm.prepend(cboxOverlay);
}

function btnNewPhoneNumber_click(ev) {
	try	{
		ev.preventDefault();
		ev.stopPropagation();

		showNewPhoneNumberPopUp();

		return false;
	} catch(e) {
		//
	}
}

function btnCancel_click(ev) {
    try {
		ev.preventDefault();
		ev.stopPropagation();

		$.fn.colorbox.close();

		return false;
	} catch(e) {
		//
	}
}

function clearControls() {
	txtNewPhoneNumberNumber.val("");
	ddlNewPhoneNumberType.val("");
	lblNewPhoneNumberMessage.html("");
	txtEditPhoneNumberNumber.val("");
	ddlEditPhoneNumberType.val("");
	lblEditPhoneNumberMessage.html("");
}

function colorbox_closed() {
    try {
        clearControls();
    } catch (e) {
        // 
    }
}

function showNewPhoneNumberPopUp() {
	// ToDo: specify the correct "width" & "height" 
	$.fn.colorbox({ inline: true, href: "#divNewPhoneNumber", width: 560, height: 250, onClosed: colorbox_closed });
}

function showEditPhoneNumberPopUp() {
	// ToDo: specify the correct "width" & "height" 
	$.fn.colorbox({ inline: true, href: "#divEditPhoneNumber", width: 560, height: 250, onClosed: colorbox_closed });
}

function showNewPhoneNumberPopUpIfNecessary() {
	if (lblNewPhoneNumberMessage.length == 0)
		return;

    if (lblNewPhoneNumberMessage.html() != "")
		showNewPhoneNumberPopUp();
}

function showEditPhoneNumberPopUpIfNecessary() {
	if (txtEditPhoneNumberNumber.length == 0 || ddlEditPhoneNumberType.length == 0 || lblEditPhoneNumberMessage.length == 0)
		return;

	if (txtEditPhoneNumberNumber.val() != "" || ddlEditPhoneNumberType.val() != "" || lblEditPhoneNumberMessage.html() != "")
		showEditPhoneNumberPopUp();
}

function showPhoneNumbersErrorMessage(message) {
	lblPhoneNumbersMessage.html(message);
}