﻿/*
    Copyright (c) 2012, Matías López
    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, are permitted 
    provided that the following conditions are met:
        *   Redistributions of source code must retain the above copyright notice, this list of 
            conditions and the following disclaimer.
        *   Redistributions in binary form must reproduce the above copyright notice, this list of 
            conditions and the following disclaimer in the documentation and/or other materials 
            provided with the distribution.
        *   Neither the name of Matías López nor the names of its contributors may be used to 
            endorse or promote products derived from this software without specific prior written 
            permission.
    
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
    IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
    AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
    OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
    POSSIBILITY OF SUCH DAMAGE.
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;

namespace mana.Data.SQL.v2
{
    /*
    public class Connection
    {
        private SqlConnection _connection;
        private SqlCommand _command;
        private SqlDataAdapter _dataAdapter;

        private string _connectionString;
        private bool _isInitialized;
        private bool _isOpen;
        
        public Connection()
            :this(null)
        { }

        public Connection(string connectionString)
        {
            _connectionString = connectionString;
        }

        public SqlConnection SqlConnection
        {
            get { return _connection; }
        }

        private void Open()
        {
            _connection = new SqlConnection();

            if (string.IsNullOrWhiteSpace(_connectionString))
            {
                int connStrCount = ConfigurationManager.ConnectionStrings.Count;
                if (connStrCount == 0)
                    throw new Exception("No connection strings configured.");

                _connectionString = ConfigurationManager.ConnectionStrings[connStrCount - 1].ConnectionString;
            }
            else
            {
                string connStrNamePrefix = "name=";
                if (_connectionString.Contains(connStrNamePrefix))
                {
                    string connStrName = _connectionString.Replace(connStrNamePrefix, string.Empty);

                    ConnectionStringSettings connStr = ConfigurationManager.ConnectionStrings[connStrName];
                    if (connStr == null)
                        throw new Exception("The connection string '" + connStrName + "' doesn't exist.");

                    _connectionString = connStr.ConnectionString;
                }
            }
            
            _connection.ConnectionString = _connectionString;
            _connection.Open();

            _command = _connection.CreateCommand();
            _command.CommandTimeout = 15;

            _isInitialized = true;
            _isOpen = true;
        }

        public int Timeout
        {
            get 
            {
                if (!_isOpen)
                    return -1;

                return _command.CommandTimeout; 
            }
            set 
            {
                if (!_isOpen)
                    return;

                _command.CommandTimeout = value; 
            }
        }

        public int Insert(List<FieldNameValue> fieldsNameValues, string tableName)
        {

        }
        
        public int Update()
        {
        }

        public int Delete()
        {
        }

        public DataReader SelectAsReader()
        {
        }

        public DataTable SelectAsDataTable()
        {
        }

        public object SelectAsValue()
        {
        }
        

        public DataReader ExecuteStoredProcedure(string name)
        {
            return ExecuteStoredProcedure(name, null);
        }

        public DataReader ExecuteStoredProcedure(string name, List<SqlParameter> parameters)
        {
            OpenConnectionIfClosed();

            _command.CommandType = CommandType.StoredProcedure;
            _command.CommandText = name;

            FillParameters(parameters);

            return new DataReader(_command.ExecuteReader());
        }

        public int ExecuteNonQuery(string commandText)
        {
            return ExecuteNonQuery(commandText, null);
        }

        public int ExecuteNonQuery(string commandText, List<SqlParameter> parameters)
        {
            OpenConnectionIfClosed();

            _command.CommandType = CommandType.Text;
            _command.CommandText = commandText;

            FillParameters(parameters);

            return _command.ExecuteNonQuery();
        }

        public DataReader ExecuteReader(string commandText)
        {
            return ExecuteReader(commandText, null);
        }

        public DataReader ExecuteReader(string commandText, List<SqlParameter> parameters)
        {
            OpenConnectionIfClosed();

            _command.CommandType = CommandType.Text;
            _command.CommandText = commandText;

            FillParameters(parameters);

            return new DataReader(_command.ExecuteReader());
        }

        public object ExecuteScalar(string commandText)
        {
            return ExecuteScalar(commandText, null);
        }

        public object ExecuteScalar(string commandText, List<SqlParameter> parameters)
        {
            OpenConnectionIfClosed();

            _command.CommandType = CommandType.Text;
            _command.CommandText = commandText;

            FillParameters(parameters);

            return _command.ExecuteScalar();
        }

        public DataTable LeerTabla(string commandText)
        {
            return LeerTabla(commandText, null);
        }

        public DataTable LeerTabla(string commandText, List<SqlParameter> parameters)
        {
            OpenConnectionIfClosed();

            _command.CommandType = CommandType.Text;
            _command.CommandText = commandText;

            FillParameters(parameters);

            DataTable datos = new DataTable("Datos");

            SqlDataAdapter dataAdapter = new SqlDataAdapter(_command);
            dataAdapter.Fill(datos);

            return datos;
        }

        private void FillParameters(List<SqlParameter> newParameters)
        {
            if (!_isOpen)
                return;

            _command.Parameters.Clear();

            if (newParameters != null)
                _command.Parameters.AddRange(newParameters.ToArray());
        }

        private void OpenConnectionIfClosed()
        {
            if (!_isOpen)
                Open();
        }
    }

    public class FieldNameValue
    {
        public string Name { get; set; }
        public string Value { get; set; }
    }
    */
}
