﻿$(document).ready(doc_ready);

// ToDo: specify the correct controls prefixes (according to their type)
var btnNewEmailAddress,
	txtNewEmailAddressAddress,
	ddlNewEmailAddressType,
	btnNewEmailAddressCancel,
	lblNewEmailAddressMessage,
	txtEditEmailAddressAddress,
	ddlEditEmailAddressType,
    btnEditEmailAddressCancel,
	lblEditEmailAddressMessage,
	lblEmailAddressesMessage;

function doc_ready() {
	try	{
		initControls();

		fixColorbox();

		showNewEmailAddressPopUpIfNecessary();
		showEditEmailAddressPopUpIfNecessary();
	} catch(e) {
		showEmailAddressesErrorMessage(e.message);
	}
}

function initControls() {
    // ToDo: specify the correct controls prefixes (according to their type)
	btnNewEmailAddress = $("#btnNewEmailAddress");
	txtNewEmailAddressAddress = $("#txtNewEmailAddressAddress");
	ddlNewEmailAddressType = $("#ddlNewEmailAddressType");
	btnNewEmailAddressCancel = $("#btnNewEmailAddressCancel");
	lblNewEmailAddressMessage = $("#lblNewEmailAddressMessage");
	txtEditEmailAddressAddress = $("#txtEditEmailAddressAddress");
	ddlEditEmailAddressType = $("#ddlEditEmailAddressType");
    btnEditEmailAddressCancel = $("#btnEditEmailAddressCancel");
	lblEditEmailAddressMessage = $("#lblEditEmailAddressMessage");
	lblEmailAddressesMessage = $("#lblEmailAddressesMessage");

	btnNewEmailAddress.click(btnNewEmailAddress_click);
    btnNewEmailAddressCancel.click(btnCancel_click);
    btnEditEmailAddressCancel.click(btnCancel_click);
}

function fixColorbox() {
    var pageForm = $( $("form")[0] );
    var cboxOverlay = $("#cboxOverlay");
    var colorbox = $("#colorbox");

    // move from "body" tag to "form" tag
    pageForm.prepend(colorbox);
    pageForm.prepend(cboxOverlay);
}

function btnNewEmailAddress_click(ev) {
	try	{
		ev.preventDefault();
		ev.stopPropagation();

		showNewEmailAddressPopUp();

		return false;
	} catch(e) {
		//
	}
}

function btnCancel_click(ev) {
    try {
		ev.preventDefault();
		ev.stopPropagation();

		$.fn.colorbox.close();

		return false;
	} catch(e) {
		//
	}
}

function clearControls() {
	txtNewEmailAddressAddress.val("");
	ddlNewEmailAddressType.val("");
	lblNewEmailAddressMessage.html("");
	txtEditEmailAddressAddress.val("");
	ddlEditEmailAddressType.val("");
	lblEditEmailAddressMessage.html("");
}

function colorbox_closed() {
    try {
        clearControls();
    } catch (e) {
        // 
    }
}

function showNewEmailAddressPopUp() {
	// ToDo: specify the correct "width" & "height" 
	$.fn.colorbox({ inline: true, href: "#divNewEmailAddress", width: 560, height: 250, onClosed: colorbox_closed });
}

function showEditEmailAddressPopUp() {
	// ToDo: specify the correct "width" & "height" 
	$.fn.colorbox({ inline: true, href: "#divEditEmailAddress", width: 560, height: 250, onClosed: colorbox_closed });
}

function showNewEmailAddressPopUpIfNecessary() {
	if (lblNewEmailAddressMessage.length == 0)
		return;

    if (lblNewEmailAddressMessage.html() != "")
		showNewEmailAddressPopUp();
}

function showEditEmailAddressPopUpIfNecessary() {
	if (txtEditEmailAddressAddress.length == 0 || ddlEditEmailAddressType.length == 0 || lblEditEmailAddressMessage.length == 0)
		return;

	if (txtEditEmailAddressAddress.val() != "" || ddlEditEmailAddressType.val() != "" || lblEditEmailAddressMessage.html() != "")
		showEditEmailAddressPopUp();
}

function showEmailAddressesErrorMessage(message) {
	lblEmailAddressesMessage.html(message);
}