﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI.WebControls;

using mana.Web.UI.WebControls;

using Library;

namespace Website.Utils
{
    public static class ExtensionMethods
    {
        public static void LoadPhoneNumberTypes(this DropDownList dropDownList)
        {
            dropDownList.Items.Add(new ListItem("Select...", string.Empty));
            dropDownList.Items.Add(new ListItem(PhoneNumberType.Home.ToString(), ((int)PhoneNumberType.Home).ToString()));
            dropDownList.Items.Add(new ListItem(PhoneNumberType.PersonalCell.ToString(), ((int)PhoneNumberType.PersonalCell).ToString()));
            dropDownList.Items.Add(new ListItem(PhoneNumberType.Work.ToString(), ((int)PhoneNumberType.Work).ToString()));
            dropDownList.Items.Add(new ListItem(PhoneNumberType.WorkCell.ToString(), ((int)PhoneNumberType.WorkCell).ToString()));
        }

        public static void LoadEmailAddressTypes(this DropDownList dropDownList)
        {
            dropDownList.Items.Add(new ListItem("Select...", string.Empty));
            dropDownList.Items.Add(new ListItem(EmailAddressType.Personal.ToString(), ((int)EmailAddressType.Personal).ToString()));
            dropDownList.Items.Add(new ListItem(EmailAddressType.Work.ToString(), ((int)EmailAddressType.Work).ToString()));
        }
    }
}